# Chadet

[![Build Status](https://travis-ci.org/styd/chadet.svg?branch=master)](https://travis-ci.org/styd/chadet)

## Background

This game is taken from the game that was played on paper by me and my friends
back in high school (although back then we only played it with 4 numbers, 1, 2,
3, and 4). We were even doing some small competitions among us for
this game and it was fun. But, sadly, nobody is playing this now, so I kinda
miss it.

I search through for the game on the internet and I found
[something similar](https://en.wikipedia.org/wiki/Bulls_and_Cows)
but not quite. So, I thought, hey, I can make this. And this is it.

It's still a simple terminal game. No fancy playing against computer yet.
Instead you just guess random characters generated by the computer and the
computer will give you the number of correct characters and correct positions.

## Preview

    $ chadet

<a href="https://asciinema.org/a/51a6mqyp4fwwc1838nilhrqzp" target="_blank"><img src="https://asciinema.org/a/51a6mqyp4fwwc1838nilhrqzp.png" width="480"/></a>


    $ chadet --chars=abc

<a href="https://asciinema.org/a/ae15mib039s4b403kxjbaf9rd" target="_blank"><img src="https://asciinema.org/a/ae15mib039s4b403kxjbaf9rd.png" width="480"/></a>


    $ chadet --number=2 --chars=123

<a href="https://asciinema.org/a/bukjpuusxdamxpsl7jwjc90x7" target="_blank"><img src="https://asciinema.org/a/bukjpuusxdamxpsl7jwjc90x7.png" width="480"/></a>

## Requirements

This game needs `bash` and `xterm` to run properly.

## Installation

    $ gem install chadet

## Usage

Read the rules of the game by typing `chadet --rules` or simply `chadet -r`. You will find out how to play the game.

<a href="https://asciinema.org/a/3o3v62f4faft0gnuqq1j9urhb" target="_blank"><img src="https://asciinema.org/a/3o3v62f4faft0gnuqq1j9urhb.png" width="480"/></a>

## Development

After checking out the repo, run `bin/setup` to install dependencies. Then, run `rake test` to run the tests. You can also run `bin/console` for an interactive prompt that will allow you to experiment.

To install this gem onto your local machine, run `bundle exec rake install`.

## Contributing

Bug reports and pull requests are welcome on GitHub at https://github.com/styd/chadet. This project is intended to be a safe, welcoming space for collaboration, and contributors are expected to adhere to the [Contributor Covenant](http://contributor-covenant.org) code of conduct.

## TODO

* Write actual test.

## License

The gem is available as open source under the terms of the [MIT License](http://opensource.org/licenses/MIT).

